#
# HackyStack GitLab CI Configuration
#

# Default Image
image: lorisleiva/laravel-docker:latest

# Pipeline Stages
stages:
- build
- test

# GitLab CI Template Jobs
include:
- template: Security/SAST.gitlab-ci.yml
- template: Dependency-Scanning.gitlab-ci.yml
- template: Secret-Detection.gitlab-ci.yml

#
# Build Stage Jobs 
#

composer:
  stage: build
  script:
    - composer install --prefer-dist --no-ansi --no-interaction --no-progress --no-scripts
    - cp .env.testing.example .env
    - php artisan key:generate
  cache:
    key: ${CI_COMMIT_REF-SLUG}-composer
    paths:
      - vendor/
  artifacts:
    expire_in: 1 month
    paths:
      - vendor/
      - .env

npm:
  stage: build
  script:
      - npm install
      - npm run production
  cache:
    key: ${CI_COMMIT_REF_SLUG}-npm
    paths:
      - node_modules/
  artifacts:
    expire_in: 1 month
    paths:
      - node_modules/
      - public/css/
      - public/js/

#
# Test Stage Jobs 
#

# codestyle:
#   stage: test
#   dependencies: []
#   script:
#     - phpcs --standard=PSR12 --extensions=php --ignore=app/Support/helpers.php app
#     - phpcs --standard=PSR12 --extensions=php --ignore=app/Support/helpers.php app

sast:
  stage: test  
  variables:
    SAST_DEFAULT_ANALYZERS: phpcs-security-audit
  # This job uses Security/SAST.gitlab-ci.yml
  # You can override the included template(s) by including variable overrides
  # See https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
  # Note that environment variables can be set in several places
  # See https://docs.gitlab.com/ee/ci/variables/#priority-of-environment-variables

# Unit and Feature Tests
# pest: 
#   stage: test
#   script: 
#     - ./vendor/bin/pest --ci
